FIND_PATH( LIBCPPCMS_INCLUDE_DIR cppcms/application.h HINTS "${CMAKE_INSTALL_PREFIX}/include/strus")
FIND_PATH( LIBBOOSTER_INCLUDE_DIR booster/shared_ptr.h HINTS "${CMAKE_INSTALL_PREFIX}/include/strus")
FIND_LIBRARY( LIBCPPCMS_LIBRARY NAMES cppcms HINTS "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/strus")
FIND_LIBRARY( LIBBOOSTER_LIBRARY NAMES booster HINTS "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/strus")

IF( LIBCPPCMS_INCLUDE_DIR AND LIBBOOSTER_INCLUDE_DIR AND LIBCPPCMS_LIBRARY AND LIBBOOSTER_LIBRARY )
   SET( LIBCPPCMS_FOUND TRUE )
ENDIF( LIBCPPCMS_INCLUDE_DIR AND LIBBOOSTER_INCLUDE_DIR AND LIBCPPCMS_LIBRARY AND LIBBOOSTER_LIBRARY )

IF( LIBCPPCMS_FOUND )
   IF( NOT CPPCMS_FIND_QUIETLY )
      MESSAGE( STATUS "libcppcms includes: ${LIBCPPCMS_INCLUDE_DIR}" )
      MESSAGE( STATUS "libcppcms libraries: ${LIBCPPCMS_LIBRARY}" )
      MESSAGE( STATUS "libbooster includes: ${LIBBOOSTER_INCLUDE_DIR}" )
      MESSAGE( STATUS "libbooster libraries: ${LIBBOOSTER_LIBRARY}" )
   ENDIF( NOT CPPCMS_FIND_QUIETLY )
ELSE( LIBCPPCMS_FOUND )
   IF( CPPCMS_FIND_REQUIRED )
      MESSAGE( FATAL_ERROR "Could not find libcppcms" )
   ENDIF( CPPCMS_FIND_REQUIRED )
ENDIF( LIBCPPCMS_FOUND )
