set(Boost_USE_MULTITHREADED ON)
set(BOOST_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/strus")
set(BOOST_LIBRARYDIR "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/strus")
find_package( Boost 1.53.0 COMPONENTS atomic QUIET)
if(NOT HAS_CXX11_STD_CHRONO)
	SET(BOOST_TIMER "timer")
endif()
if( Boost_ATOMIC_FOUND )
	if(APPLE OR WIN32)
		find_package( Boost 1.53.0 REQUIRED COMPONENTS filesystem thread-mt system date_time atomic-mt program_options ${BOOST_TIMER})
	else()
		find_package( Boost 1.53.0 REQUIRED COMPONENTS filesystem thread system date_time atomic program_options ${BOOST_TIMER})
	endif()
else()
	if(APPLE OR WIN32)
		find_package( Boost 1.53.0 REQUIRED COMPONENTS filesystem thread-mt system date_time program_options ${BOOST_TIMER})
	else()
		find_package( Boost 1.53.0 REQUIRED COMPONENTS filesystem thread system date_time program_options ${BOOST_TIMER})
	endif()
endif()

MESSAGE( STATUS "Boost includes: ${Boost_INCLUDE_DIRS}" )
MESSAGE( STATUS "Boost library directories: ${Boost_LIBRARY_DIRS}" )
MESSAGE( STATUS "Boost libraries: ${Boost_LIBRARIES}" )
