/*
 * Copyright (c) 2014 Patrick P. Frey
 * Copyright (c) 2015,2016 Andreas Baumann
 * Copyright (c) 2015,2016 Eurospider IT AG Zurich
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#ifndef ERROR_CODES_H
#define ERROR_CODES_H

// Important note: Do NOT delete entries, barely comment them out!
// Do not reuse entries, just creating new ones is allowed!
// This ensures the client error codes remain consistent over time.

const int ERROR_BASE										= 1000;

// generic protocol errors

const int ERROR_ILLEGAL_METHOD								= ERROR_BASE + 1;
const int ERROR_IILLEGAL_JSON								= ERROR_BASE + 2;
const int ERROR_NOT_IMPLEMENTED								= ERROR_BASE + 3;

// errors in index management

const int ERROR_INDEX 										= 2000;

const int ERROR_INDEX_ILLEGAL_JSON							= ERROR_INDEX + 1;

const int ERROR_INDEX_CREATE_CMD							= ERROR_INDEX + 100;
const int ERROR_INDEX_CREATE_DATABASE_EXISTS				= ERROR_INDEX_CREATE_CMD + 1;
const int ERROR_INDEX_CREATE_DATABASE_INTERFACE 			= ERROR_INDEX_CREATE_CMD + 2;
const int ERROR_INDEX_CREATE_STORAGE_INTERFACE	 			= ERROR_INDEX_CREATE_CMD + 3;
// deprecated in version 0.0.5 
// const int ERROR_INDEX_CREATE_CMD_CREATE_DATABASE			= ERROR_INDEX_CREATE_CMD + 4;
// const int ERROR_INDEX_CREATE_CMD_CREATE_CLIENT				= ERROR_INDEX_CREATE_CMD + 5;
const int ERROR_INDEX_CREATE_CMD_MKDIR_STORAGE_DIR			= ERROR_INDEX_CREATE_CMD + 6;

const int ERROR_INDEX_DESTROY_CMD 							= ERROR_INDEX + 200;
const int ERROR_INDEX_DESTROY_CMD_NO_SUCH_DATABASE			= ERROR_INDEX_DESTROY_CMD + 1;
const int ERROR_INDEX_DESTROY_CMD_DESTROY_DATABASE			= ERROR_INDEX_DESTROY_CMD + 2;

const int ERROR_INDEX_STATS_CMD								= ERROR_INDEX + 300;
const int ERROR_INDEX_STATS_CMD_ILLEGAL_STORAGE_DIR			= ERROR_INDEX_STATS_CMD + 1;
const int ERROR_INDEX_STATS_CMD_NO_SUCH_DATABASE			= ERROR_INDEX_STATS_CMD + 2;
const int ERROR_INDEX_STATS_CMD_CREATE_DATABASE_CLIENT		= ERROR_INDEX_STATS_CMD + 3;
const int ERROR_INDEX_STATS_CMD_CREATE_STORAGE_CLIENT		= ERROR_INDEX_STATS_CMD + 4;

const int ERROR_INDEX_CONFIG_CMD							= ERROR_INDEX + 400;
const int ERROR_INDEX_CONFIG_CMD_ILLEGAL_STORAGE_DIR		= ERROR_INDEX_CONFIG_CMD + 1;
const int ERROR_INDEX_CONFIG_CMD_NO_SUCH_DATABASE			= ERROR_INDEX_CONFIG_CMD + 2;
const int ERROR_INDEX_CONFIG_CMD_CREATE_DATABASE_CLIENT		= ERROR_INDEX_CONFIG_CMD + 3;
const int ERROR_INDEX_CONFIG_CMD_CREATE_STORAGE_CLIENT		= ERROR_INDEX_CONFIG_CMD + 4;
const int ERROR_INDEX_CONFIG_CMD_CREATE_METADATA_READER		= ERROR_INDEX_CONFIG_CMD + 5;

const int ERROR_INDEX_OPEN_CMD					= ERROR_INDEX + 500;
const int ERROR_INDEX_OPEN_CMD_NO_SUCH_DATABASE			= ERROR_INDEX_OPEN_CMD + 1;
const int ERROR_INDEX_OPEN_CMD_CREATE_DATABASE_CLIENT		= ERROR_INDEX_OPEN_CMD + 2;
const int ERROR_INDEX_OPEN_CMD_CREATE_STORAGE_CLIENT		= ERROR_INDEX_OPEN_CMD + 3;

const int ERROR_INDEX_CLOSE_CMD					= ERROR_INDEX + 600;
const int ERROR_INDEX_CLOSE_CMD_NO_SUCH_DATABASE		= ERROR_INDEX_CLOSE_CMD + 1;

const int ERROR_INDEX_SWAP_CMD					= ERROR_INDEX + 700;
const int ERROR_INDEX_SWAP_CMD_NO_SUCH_DATABASE1		= ERROR_INDEX_SWAP_CMD + 1;
const int ERROR_INDEX_SWAP_CMD_NO_SUCH_DATABASE2		= ERROR_INDEX_SWAP_CMD + 2;
const int ERROR_INDEX_SWAP_CMD_RENAME_ERROR				= ERROR_INDEX_SWAP_CMD + 3;

const int ERROR_INDEX_RENAME_CMD					= ERROR_INDEX + 800;
const int ERROR_INDEX_RENAME_CMD_NO_SUCH_DATABASE		= ERROR_INDEX_RENAME_CMD + 1;
const int ERROR_INDEX_RENAME_CMD_ALREADY_EXISTS		= ERROR_INDEX_RENAME_CMD + 2;
const int ERROR_INDEX_RENAME_CMD_RENAME_ERROR				= ERROR_INDEX_RENAME_CMD + 3;

// errors in document management

const int ERROR_DOCUMENT_CMD									= 3000;

const int ERROR_DOCUMENT_INSERT_CMD							= ERROR_DOCUMENT_CMD + 100;
const int ERROR_DOCUMENT_INSERT_CMD_NO_SUCH_DATABASE		= ERROR_DOCUMENT_INSERT_CMD + 1;
const int ERROR_DOCUMENT_INSERT_CMD_CREATE_DATABASE_CLIENT	= ERROR_DOCUMENT_INSERT_CMD + 2;
const int ERROR_DOCUMENT_INSERT_CMD_CREATE_STORAGE_CLIENT	= ERROR_DOCUMENT_INSERT_CMD + 3;
const int ERROR_DOCUMENT_INSERT_CMD_CREATE_STORAGE_TRANSACTION = ERROR_DOCUMENT_INSERT_CMD + 4;
const int ERROR_DOCUMENT_INSERT_ILLEGAL_JSON				= ERROR_DOCUMENT_INSERT_CMD + 5;	
const int ERROR_DOCUMENT_INSERT_CMD_DOCID_REQUIRED			= ERROR_DOCUMENT_INSERT_CMD + 6;
const int ERROR_DOCUMENT_INSERT_TOO_BIG_POSITION			= ERROR_DOCUMENT_INSERT_CMD + 7;
const int ERROR_DOCUMENT_INSERT_CMD_GET_STORAGE_TRANSACTION	= ERROR_DOCUMENT_INSERT_CMD + 8;

const int ERROR_DOCUMENT_DELETE_CMD 						= ERROR_DOCUMENT_CMD + 200;
const int ERROR_DOCUMENT_DELETE_CMD_NO_SUCH_DATABASE		= ERROR_DOCUMENT_DELETE_CMD + 1;
const int ERROR_DOCUMENT_DELETE_CMD_CREATE_DATABASE_CLIENT	= ERROR_DOCUMENT_DELETE_CMD + 2;
const int ERROR_DOCUMENT_DELETE_CMD_CREATE_STORAGE_CLIENT	= ERROR_DOCUMENT_DELETE_CMD + 3;
const int ERROR_DOCUMENT_DELETE_CMD_NO_SUCH_DOCUMENT		= ERROR_DOCUMENT_DELETE_CMD + 4;
const int ERROR_DOCUMENT_DELETE_CMD_CREATE_STORAGE_TRANSACTION = ERROR_DOCUMENT_DELETE_CMD + 5;
const int ERROR_DOCUMENT_DELETE_ILLEGAL_JSON				= ERROR_DOCUMENT_DELETE_CMD + 6;	
const int ERROR_DOCUMENT_DELETE_CMD_DOCID_REQUIRED			= ERROR_DOCUMENT_DELETE_CMD + 7;

const int ERROR_DOCUMENT_GET_CMD							= ERROR_DOCUMENT_CMD + 300;
const int ERROR_DOCUMENT_GET_CMD_NO_SUCH_DATABASE			= ERROR_DOCUMENT_GET_CMD + 1;
const int ERROR_DOCUMENT_GET_CMD_CREATE_DATABASE_CLIENT		= ERROR_DOCUMENT_GET_CMD + 2;
const int ERROR_DOCUMENT_GET_CMD_CREATE_STORAGE_CLIENT		= ERROR_DOCUMENT_GET_CMD + 3;
const int ERROR_DOCUMENT_GET_CMD_CREATE_STORAGE_TRANSACTION = ERROR_DOCUMENT_GET_CMD + 4;
const int ERROR_DOCUMENT_GET_ILLEGAL_JSON					= ERROR_DOCUMENT_GET_CMD + 5;	
const int ERROR_DOCUMENT_GET_CMD_CREATE_METADATA_READER		= ERROR_DOCUMENT_GET_CMD + 6;
const int ERROR_DOCUMENT_GET_CMD_NO_SUCH_DOCUMENT			= ERROR_DOCUMENT_GET_CMD + 7;
const int ERROR_DOCUMENT_GET_CMD_CREATE_ATTRIBUTE_READER	= ERROR_DOCUMENT_GET_CMD + 8;

const int ERROR_DOCUMENT_EXISTS_CMD							= ERROR_DOCUMENT_CMD + 400;
const int ERROR_DOCUMENT_EXISTS_CMD_NO_SUCH_DATABASE		= ERROR_DOCUMENT_EXISTS_CMD + 1;
const int ERROR_DOCUMENT_EXISTS_CMD_CREATE_DATABASE_CLIENT	= ERROR_DOCUMENT_EXISTS_CMD + 2;
const int ERROR_DOCUMENT_EXISTS_CMD_CREATE_STORAGE_CLIENT	= ERROR_DOCUMENT_EXISTS_CMD + 3;
const int ERROR_DOCUMENT_EXISTS_CMD_CREATE_STORAGE_TRANSACTION = ERROR_DOCUMENT_EXISTS_CMD + 4;
const int ERROR_DOCUMENT_EXISTS_ILLEGAL_JSON				= ERROR_DOCUMENT_EXISTS_CMD + 5;	

// errors in query

const int ERROR_QUERY_CMD									= 4000;

const int ERROR_QUERY_CMD_NO_SUCH_DATABASE					= ERROR_QUERY_CMD + 1;
const int ERROR_QUERY_CMD_CREATE_DATABASE_CLIENT			= ERROR_QUERY_CMD + 2;
const int ERROR_QUERY_CMD_CREATE_STORAGE_CLIENT				= ERROR_QUERY_CMD + 3;
const int ERROR_QUERY_CMD_GET_ILLEGAL_JSON					= ERROR_QUERY_CMD + 4;
const int ERROR_QUERY_CMD_CREATE_QUERY_EVAL_INTERFACE		= ERROR_QUERY_CMD + 5;
const int ERROR_QUERY_CMD_CREATE_QUERY						= ERROR_QUERY_CMD + 6;
const int ERROR_QUERY_CMD_CREATE_QUERY_PROCESSOR			= ERROR_QUERY_CMD + 7;
const int ERROR_QUERY_CMD_GET_WEIGHTING_FUNCTION			= ERROR_QUERY_CMD + 8;
const int ERROR_QUERY_CMD_GET_SUMMARIZER_FUNCTION			= ERROR_QUERY_CMD + 9;
const int ERROR_QUERY_CMD_GET_SUMMARIZER_FUNCTION_INSTANCE	= ERROR_QUERY_CMD + 10;
const int ERROR_QUERY_CMD_QUERY_EVALUATE					= ERROR_QUERY_CMD + 11;
const int ERROR_QUERY_CMD_GET_WEIGHTING_FUNCTION_PARAMETER	= ERROR_QUERY_CMD + 12;
const int ERROR_QUERY_CMD_GET_SUMMARIZER_FUNCTION_CONTEXT	= ERROR_QUERY_CMD + 13;

// errors in other commands

const int ERROR_OTHER_CMD									= 5000;

const int ERROR_OTHER_CMD_CREATE_QUERY_PROCESSOR			= ERROR_OTHER_CMD + 1;

// transactions

const int ERROR_TRANSACTION_CMD									= 6000;

const int ERROR_TRANSACTION_BEGIN_CMD							= ERROR_TRANSACTION_CMD + 100;
const int ERROR_TRANSACTION_BEGIN_CMD_NO_SUCH_DATABASE		= ERROR_TRANSACTION_BEGIN_CMD + 1;
const int ERROR_TRANSACTION_BEGIN_CMD_CREATE_DATABASE_CLIENT	= ERROR_TRANSACTION_BEGIN_CMD + 2;
const int ERROR_TRANSACTION_BEGIN_CMD_CREATE_STORAGE_CLIENT	= ERROR_TRANSACTION_BEGIN_CMD + 3;
const int ERROR_TRANSACTION_BEGIN_CMD_CREATE_STORAGE_TRANSACTION = ERROR_TRANSACTION_BEGIN_CMD + 4;
const int ERROR_TRANSACTION_BEGIN_ILLEGAL_JSON				= ERROR_TRANSACTION_BEGIN_CMD + 5;
const int ERROR_TRANSACTION_BEGIN_CMD_DOCID_REQUIRED			= ERROR_TRANSACTION_BEGIN_CMD + 6;

const int ERROR_TRANSACTION_COMMIT_CMD							= ERROR_TRANSACTION_CMD + 200;
const int ERROR_TRANSACTION_COMMIT_CMD_NO_SUCH_DATABASE		= ERROR_TRANSACTION_COMMIT_CMD + 1;
const int ERROR_TRANSACTION_COMMIT_CMD_CREATE_DATABASE_CLIENT	= ERROR_TRANSACTION_COMMIT_CMD + 2;
const int ERROR_TRANSACTION_COMMIT_CMD_CREATE_STORAGE_CLIENT	= ERROR_TRANSACTION_COMMIT_CMD + 3;
const int ERROR_TRANSACTION_COMMIT_CMD_GET_STORAGE_TRANSACTION = ERROR_TRANSACTION_COMMIT_CMD + 4;
const int ERROR_TRANSACTION_COMMIT_ILLEGAL_JSON				= ERROR_TRANSACTION_COMMIT_CMD + 5;
const int ERROR_TRANSACTION_COMMIT_CMD_DOCID_REQUIRED			= ERROR_TRANSACTION_COMMIT_CMD + 6;

const int ERROR_TRANSACTION_ROLLBACK_CMD							= ERROR_TRANSACTION_CMD + 300;
const int ERROR_TRANSACTION_ROLLBACK_CMD_NO_SUCH_DATABASE		= ERROR_TRANSACTION_ROLLBACK_CMD + 1;
const int ERROR_TRANSACTION_ROLLBACK_CMD_CREATE_DATABASE_CLIENT	= ERROR_TRANSACTION_ROLLBACK_CMD + 2;
const int ERROR_TRANSACTION_ROLLBACK_CMD_CREATE_STORAGE_CLIENT	= ERROR_TRANSACTION_ROLLBACK_CMD + 3;
const int ERROR_TRANSACTION_ROLLBACK_CMD_GET_STORAGE_TRANSACTION = ERROR_TRANSACTION_ROLLBACK_CMD + 4;
const int ERROR_TRANSACTION_ROLLBACK_ILLEGAL_JSON				= ERROR_TRANSACTION_ROLLBACK_CMD + 5;
const int ERROR_TRANSACTION_ROLLBACK_CMD_DOCID_REQUIRED			= ERROR_TRANSACTION_ROLLBACK_CMD + 6;

const int ERROR_TRANSACTION_LIST_CMD							= ERROR_TRANSACTION_CMD + 400;
const int ERROR_TRANSACTION_LIST_CMD_NO_SUCH_DATABASE			= ERROR_TRANSACTION_LIST_CMD + 1;

#endif
